# MNIST Keras example Using IBM Distributed Deep Learning

## About

The `mnist-tf-keras-simple.py` script is a simple example that demonstrates how to modify a TensorFlow Keras script to use IBM Distributed Deep Learning (DDL). This example uses TensorFlow's Keras API to both define the model and train the model.

The `mnist-tf-keras-adv.py` script is a more advanced example that demonstrates how to modify a TensorFlow Keras script to use IBM Distributed Deep Learning (DDL). This example uses TensorFlow's Keras API to define the model, but defines a custom training function.

## Running the examples

Before running either of the scripts, make sure there is a conda environment activated with the `ddl-tensorflow` package installed.

The examples should also be copied into a user directory by running the following command:

```bash
$ ddl-tensorflow-install-samples <somedir>
```

To run `mnist-tf-keras-simple.py` on two machines named host1 and host2:

```bash
$ ddlrun -H host1,host2 python mnist-tf-keras-simple.py
```

To run `mnist-tf-keras-adv.py` on two machines named host1 and host2:

```bash
$ ddlrun -H host1,host2 python mnist-tf-keras-adv.py
```

&copy; Copyright IBM Corporation 2018, 2019
